package com.loafle.overflow.central.module.infra.dao;

import java.util.List;

import com.loafle.overflow.model.infra.InfraHostPort;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Created by insanity on 17. 6. 23.
 */
@Repository
public interface InfraHostPortDAO extends JpaRepository<InfraHostPort, Long> {
  @Query("SELECT ihp from InfraHostPort ihp where ihp.infraHostIP.id = :infraHostIPId")
  List<InfraHostPort> findAllByInfraHostIPId(@Param("infraHostIPId") Long infraHostIPId);

  @Query("SELECT ihp from InfraHostPort ihp where ihp.infraHostIP.id = :infraHostIPId AND metaPortType.key = :metaPortTypeKey")
  List<InfraHostPort> findAllByInfraHostIPIdAndMetaPortTypeKey(@Param("infraHostIPId") Long infraHostIPId,
      @Param("metaPortTypeKey") String metaPortTypeKey);

  @Query("SELECT ihp from InfraHostPort ihp where ihp.infraHostIP.id = :infraHostIPId AND metaPortType.key = :metaPortTypeKey AND port = :port")
  InfraHostPort findByInfraHostIPIdAndMetaPortTypeKeyAndPort(@Param("infraHostIPId") Long infraHostIPId,
      @Param("metaPortTypeKey") String metaPortTypeKey, @Param("port") Integer port);
}