package com.loafle.overflow.central.module.meta.service;

import com.loafle.overflow.central.module.meta.dao.MetaDisplayItemMappingDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaDisplayItemMapping;
import com.loafle.overflow.service.central.meta.MetaDisplayItemMappingService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by insanity on 17. 11. 7.
 */
@Service("MetaDisplayItemMappingService")
public class CentralMetaDisplayItemMappingService implements MetaDisplayItemMappingService {
   @Autowired
   private MetaDisplayItemMappingDAO metaDisplayItemMappingDAO;

  @Override
  public MetaDisplayItemMapping regist(MetaDisplayItemMapping metaDisplayItemMapping) throws OverflowException {
    return this.metaDisplayItemMappingDAO.save(metaDisplayItemMapping);
  }

  @Override
  public List<MetaDisplayItemMapping> readAllByMetaDisplayItemID(Long metaDisplayItemID) throws OverflowException {
    return this.metaDisplayItemMappingDAO.findAllByMetaDisplayItemId(metaDisplayItemID);
  }

  @Override
  public List<MetaDisplayItemMapping> readAllByMetaCrawlerMappingID(Long metaCrawlerMappingID) throws OverflowException {
    return this.metaDisplayItemMappingDAO.findAllByMetaCrawlerMappingId(metaCrawlerMappingID);
  }

  @Override
  public List<MetaDisplayItemMapping> readAll() throws OverflowException {
    return this.metaDisplayItemMappingDAO.findAll();
  }
}
