package com.loafle.overflow.central.module.sensor.service;

import com.loafle.overflow.central.module.meta.dao.MetaCrawlerMappingDAO;
import com.loafle.overflow.central.module.meta.dao.MetaDisplayItemMappingDAO;
import com.loafle.overflow.central.spring.AppConfigTest;

import java.util.ArrayList;
import java.util.List;

import com.loafle.overflow.model.meta.MetaCrawlerMapping;
import com.loafle.overflow.model.sensor.Sensor;
import com.loafle.overflow.model.target.Target;
import com.loafle.overflow.service.central.sensor.SensorService;
import com.loafle.overflow.service.central.target.TargetService;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by insanity on 17. 6. 28.
 */
// @Ignore
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { AppConfigTest.class })
public class SensorServiceTest {
  @Autowired
  SensorService sensorService;

  @Autowired
  TargetService targetService;

  @Autowired
  MetaDisplayItemMappingDAO metaDisplayItemMappingService;
  @Autowired
  MetaCrawlerMappingDAO metaCrawlerMappingDAO;

  @Test
  @Ignore
  public void regist() throws Exception {

    Target target = this.targetService.read(Long.valueOf(1));
    Sensor sensor = new Sensor();
    sensor.setTarget(target);

    List<MetaCrawlerMapping> metaCrawlerMappings = this.metaCrawlerMappingDAO.findAll();
    sensor.setMetaCrawlerMapping(metaCrawlerMappings.get(0));

    Sensor result = this.sensorService.regist(sensor, this.metaDisplayItemMappingService.findAll());
    Assert.assertNotNull(result);
  }

  @Test
  @Ignore
  public void readAllByTargetID() throws Exception {
    this.regist();
    Assert.assertNotNull(this.sensorService.readAllByTargetID(Long.valueOf(1)));
  }

  @Test
  @Ignore
  public void readAllByTargetIn() throws Exception {
    this.regist();
    List<Target> targets = new ArrayList<Target>();
    Target t1 = new Target();
    t1.setId(Long.valueOf(1));
    Target t2 = new Target();
    t2.setId(Long.valueOf(2));
    targets.add(t1);
    targets.add(t2);
    List<Sensor> sensors = this.sensorService.readAllByTargetIn(targets);
    Assert.assertNotNull(sensors);
  }

  @Test
  @Ignore
  public void readAllByTargetInfraProbeID() throws Exception {
    this.regist();
    List<Sensor> sensors = this.sensorService.readAllByTargetInfraProbeID(Long.valueOf(1));
    Assert.assertNotNull(sensors);
  }
}
